/*	File			NoughtsCrosses_General.h
	Purpose			Network Game (Noughts and Crosses) Common header code
	Author			Richard Anthony	(ar26@gre.ac.uk)
	Date			Updated April 2014 (originally December 2003)
*/

#pragma once

#define PORT 8000  // Default port 8000 decimal

#define MAX_ALIAS_LEN 15
enum MessageType {REGISTER_ALIAS, PLAYER_LIST, CHOOSE_OPPONENT, LOCAL_CELL_SELECTION,
					OPPONENT_CELL_SELECTION, START_OF_GAME, END_OF_GAME, 
					CLIENT_DISCONNECT};

enum CodeType {END_OF_GAME_DRAW, END_OF_GAME_WIN, END_OF_GAME_LOOSE};

struct Message_PDU {
	MessageType iMessageType;
	char cAlias[MAX_ALIAS_LEN +1];
	char cPlayerList[(MAX_ALIAS_LEN +1) *10]; //comma-separated list of alias'
	int iCell;
	CodeType iCode;
	int iToken;
	bool bFirstMove;
};
